Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
Botan::GOST_3410_PrivateKey Class Referencefinal

`#include <gost_3410.h>`

Inheritance diagram for Botan::GOST_3410_PrivateKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
Signature_Format | default_x509_signature_format () const override
std::vector< uint8_t > | DER_domain () const
const EC_Group & | domain () const
EC_Group_Encoding | domain_format () const
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
virtual OID | get_oid () const
| GOST_3410_PrivateKey (const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &key_bits)
| GOST_3410_PrivateKey (RandomNumberGenerator &rng, const EC_Group &domain, const BigInt &x=0)
size_t | key_length () const override
size_t | message_part_size () const override
size_t | message_parts () const override
AlgorithmIdentifier | pkcs8_algorithm_identifier () const override
PointGFp::Compression_Type | point_encoding () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
const BigInt & | private_value () const
std::vector< uint8_t > | public_key_bits () const override
const PointGFp & | public_point () const
void | set_parameter_encoding (EC_Group_Encoding enc)
void | set_point_encoding (PointGFp::Compression_Type enc)
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const

## Protected Attributes
EC_Group_Encoding | m_domain_encoding
EC_Group | m_domain_params
PointGFp::Compression_Type | m_point_encoding = PointGFp::UNCOMPRESSED
BigInt | m_private_key
PointGFp | m_public_key

## Detailed Description

GOST-34.10 Private Key

Definition at line 70 of file gost_3410.h.

## Constructor & Destructor Documentation

Botan::GOST_3410_PrivateKey::GOST_3410_PrivateKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | key_bits
| ) |  |
| inline

Load a private key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | ECPrivateKey bits

Definition at line 79 of file gost_3410.h.

80 :
81 EC_PrivateKey(alg_id, key_bits) {}
Botan::EC_PrivateKey::EC_PrivateKey
EC_PrivateKey()=default

Botan::GOST_3410_PrivateKey::GOST_3410_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | const EC_Group & | domain,
|  | const BigInt & | x = `0`
| ) |  |

Generate a new private key

Parameters

  rng | a random number generator
  domain | parameters to used for this key
  x | the private key; if zero, a new random key is generated

Definition at line 101 of file gost_3410.cpp.

References Botan::EC_Group::get_p_bits(), Botan::EC_PublicKey::m_domain_params, and Botan::ASN1::to_string().

103 :
104 EC_PrivateKey(rng, domain, x)
105 {
106 const size_t p_bits = m_domain_params.get_p_bits();
107 if(p_bits != 256 && p_bits != 512)
108 throw Decoding_Error("GOST-34.10-2012 is not defined for parameters of size " +
109 std::to_string(p_bits));
110 }
Botan::EC_PrivateKey::EC_PrivateKey
EC_PrivateKey()=default
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:213
Botan::EC_Group::get_p_bits
size_t get_p_bits() const
Definition: ec_group.cpp:438
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:114

## Member Function Documentation

std::string Botan::GOST_3410_PublicKey::algo_name | ( |  | ) | const
| override virtual inherited

Get this keys algorithm name.

Returns
  this keys algorithm name

Implements Botan::Public_Key.

Definition at line 43 of file gost_3410.cpp.

References Botan::EC_PublicKey::domain(), Botan::EC_Group::get_p_bits(), and Botan::ASN1::to_string().

Referenced by create_signature_op(), and Botan::GOST_3410_PublicKey::create_verification_op().

44 {
45 const size_t p_bits = domain().get_p_bits();
46
47 if(p_bits == 256 || p_bits == 512)
48 return "GOST-34.10-2012-" + std::to_string(p_bits);
49 else
50 throw Encoding_Error("GOST-34.10-2012 is not defined for parameters of this size");
51 }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:213
Botan::EC_Group::get_p_bits
size_t get_p_bits() const
Definition: ec_group.cpp:438

AlgorithmIdentifier Botan::GOST_3410_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Reimplemented from Botan::EC_PublicKey.

Definition at line 53 of file gost_3410.cpp.

References Botan::EC_PublicKey::domain(), Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::get_oid(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

54 {
55 std::vector<uint8_t> params;
56
57 DER_Encoder(params)
58 .start_cons(SEQUENCE)
59 .encode(domain().get_curve_oid())
60 .end_cons();
61
62 return AlgorithmIdentifier(get_oid(), params);
63 }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53
Botan::SEQUENCE
Definition: asn1_obj.h:40

bool Botan::EC_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual inherited

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::ECDSA_PrivateKey, Botan::SM2_PrivateKey, Botan::ECGDSA_PrivateKey, and Botan::ECKCDSA_PrivateKey.

Definition at line 56 of file ecc_key.cpp.

References Botan::EC_PublicKey::m_domain_params, Botan::EC_PublicKey::public_point(), Botan::EC_Group::verify_group(), and Botan::EC_Group::verify_public_element().

58 {
59 return m_domain_params.verify_group(rng) &&
60 m_domain_params.verify_public_element(public_point());
61 }
Botan::EC_PublicKey::public_point
const PointGFp & public_point() const
Definition: ecc_key.h:57
Botan::EC_Group::verify_public_element
bool verify_public_element(const PointGFp &y) const
Definition: ec_group.cpp:665
Botan::EC_Group::verify_group
bool verify_group(RandomNumberGenerator &rng, bool strong=false) const
Definition: ec_group.cpp:688
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:114

std::unique_ptr< PK_Ops::Decryption > Botan::Private_Key::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, Botan::SM2_PrivateKey, and Botan::ElGamal_PrivateKey.

Definition at line 114 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Decryptor_EME::PK_Decryptor_EME().

117 {
118 throw Lookup_Error(algo_name() + " does not support decryption");
119 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 91 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::Private_Key::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PrivateKey, and Botan::McEliece_PrivateKey.

Definition at line 122 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Decryptor::PK_KEM_Decryptor().

125 {
126 throw Lookup_Error(algo_name() + " does not support KEM decryption");
127 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 99 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ECDH_PrivateKey, Botan::Curve25519_PrivateKey, and Botan::DH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Signature > Botan::GOST_3410_PrivateKey::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 244 of file gost_3410.cpp.

References Botan::GOST_3410_PublicKey::algo_name().

247 {
248 if(provider == "base" || provider.empty())
249 return std::unique_ptr<PK_Ops::Signature>(new GOST_3410_Signature_Operation(*this, params));
250 throw Provider_Not_Found(algo_name(), provider);
251 }
Botan::GOST_3410_PublicKey::algo_name
std::string algo_name() const override
Definition: gost_3410.cpp:43

std::unique_ptr< PK_Ops::Verification > Botan::GOST_3410_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 235 of file gost_3410.cpp.

References Botan::GOST_3410_PublicKey::algo_name().

237 {
238 if(provider == "base" || provider.empty())
239 return std::unique_ptr<PK_Ops::Verification>(new GOST_3410_Verification_Operation(*this, params));
240 throw Provider_Not_Found(algo_name(), provider);
241 }
Botan::GOST_3410_PublicKey::algo_name
std::string algo_name() const override
Definition: gost_3410.cpp:43

Signature_Format Botan::GOST_3410_PublicKey::default_x509_signature_format | ( |  | ) | const
| inline override virtual inherited

Reimplemented from Botan::Public_Key.

Definition at line 56 of file gost_3410.h.

References Botan::IEEE_1363.

57 { return IEEE_1363; }
Botan::IEEE_1363
Definition: pk_keys.h:24

std::vector<uint8_t> Botan::EC_PublicKey::DER_domain | ( |  | ) | const
| inline inherited

Return the DER encoding of this keys domain in whatever format is preset for this particular key

Definition at line 90 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::algorithm_identifier().

91 { return domain().DER_encode(domain_format()); }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::EC_Group::DER_encode
std::vector< uint8_t > DER_encode(EC_Group_Encoding form) const
Definition: ec_group.cpp:592
Botan::EC_PublicKey::domain_format
EC_Group_Encoding domain_format() const
Definition: ecc_key.h:97

const EC_Group& Botan::EC_PublicKey::domain | ( |  | ) | const
| inline inherited

Get the domain parameters of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the domain parameters of this key

Definition at line 72 of file ecc_key.h.

Referenced by Botan::GOST_3410_PublicKey::algo_name(), Botan::GOST_3410_PublicKey::algorithm_identifier(), botan_pubkey_sm2_compute_za(), Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), Botan::EC_PublicKey::key_length(), Botan::ECDSA_PublicKey::recovery_param(), and Botan::SM2_PrivateKey::SM2_PrivateKey().

72 { return m_domain_params; }
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:114

EC_Group_Encoding Botan::EC_PublicKey::domain_format | ( |  | ) | const
| inline inherited

Get the domain parameter encoding to be used when encoding this key.

Returns
  the encoding to use

Definition at line 97 of file ecc_key.h.

98 { return m_domain_encoding; }
Botan::EC_PublicKey::m_domain_encoding
EC_Group_Encoding m_domain_encoding
Definition: ecc_key.h:116

size_t Botan::EC_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 25 of file ecc_key.cpp.

References Botan::ecp_work_factor(), and Botan::EC_PublicKey::key_length().

26 {
27 return ecp_work_factor(key_length());
28 }
Botan::ecp_work_factor
size_t ecp_work_factor(size_t bits)
Definition: workfactor.cpp:14
Botan::EC_PublicKey::key_length
size_t key_length() const override
Definition: ecc_key.cpp:20

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 216 of file pk_keys.h.

217 {
218 return fingerprint_private(alg); // match behavior in previous versions
219 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

References Botan::create_hex_fingerprint(), and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

References Botan::create_hex_fingerprint(), and Botan::Public_Key::subject_public_key().

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

size_t Botan::EC_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 20 of file ecc_key.cpp.

References Botan::EC_PublicKey::domain(), and Botan::EC_Group::get_p_bits().

Referenced by Botan::EC_PublicKey::estimated_strength().

21 {
22 return domain().get_p_bits();
23 }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::EC_Group::get_p_bits
size_t get_p_bits() const
Definition: ec_group.cpp:438

size_t Botan::GOST_3410_PublicKey::message_part_size | ( |  | ) | const
| inline override virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented from Botan::Public_Key.

Definition at line 53 of file gost_3410.h.

54 { return domain().get_order().bytes(); }
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::EC_Group::get_order
const BigInt & get_order() const
Definition: ec_group.cpp:478
Botan::BigInt::bytes
size_t bytes() const
Definition: bigint.cpp:273

size_t Botan::GOST_3410_PublicKey::message_parts | ( |  | ) | const
| inline override virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented from Botan::Public_Key.

Definition at line 51 of file gost_3410.h.

51 { return 2; }

AlgorithmIdentifier Botan::GOST_3410_PrivateKey::pkcs8_algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented from Botan::Private_Key.

Definition at line 93 of file gost_3410.h.

References Botan::EC_PublicKey::algorithm_identifier().

94 { return EC_PublicKey::algorithm_identifier(); }
Botan::EC_PublicKey::algorithm_identifier
AlgorithmIdentifier algorithm_identifier() const override
Definition: ecc_key.cpp:64

PointGFp::Compression_Type Botan::EC_PublicKey::point_encoding | ( |  | ) | const
| inline inherited

Get the point encoding method to be used when encoding this key.

Returns
  the encoding to use

Definition at line 104 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::public_key_bits().

105 { return m_point_encoding; }
Botan::EC_PublicKey::m_point_encoding
PointGFp::Compression_Type m_point_encoding
Definition: ecc_key.h:117

secure_vector< uint8_t > Botan::EC_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 147 of file ecc_key.cpp.

References Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::PointGFp::encode(), Botan::BigInt::encode_1363(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::EC_PublicKey::m_public_key, Botan::OCTET_STRING, Botan::PRIVATE, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

148 {
149 return DER_Encoder()
150 .start_cons(SEQUENCE)
151 .encode(static_cast<size_t>(1))
152 .encode(BigInt::encode_1363(m_private_key, m_private_key.bytes()), OCTET_STRING)
153 .start_cons(ASN1_Tag(1), PRIVATE)
154 .encode(m_public_key.encode(PointGFp::Compression_Type::UNCOMPRESSED), BIT_STRING)
155 .end_cons()
156 .end_cons()
157 .get_contents();
158 }
Botan::EC_PrivateKey::m_private_key
BigInt m_private_key
Definition: ecc_key.h:167
Botan::EC_PublicKey::m_public_key
PointGFp m_public_key
Definition: ecc_key.h:115
Botan::PRIVATE
Definition: asn1_obj.h:30
Botan::ASN1_Tag
ASN1_Tag
Definition: asn1_obj.h:23
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::OCTET_STRING
Definition: asn1_obj.h:36
Botan::BIT_STRING
Definition: asn1_obj.h:35
Botan::BigInt::encode_1363
static secure_vector< uint8_t > encode_1363(const BigInt &n, size_t bytes)
Definition: big_code.cpp:111
Botan::PointGFp::encode
std::vector< uint8_t > encode(PointGFp::Compression_Type format) const
Definition: point_gfp.cpp:595
Botan::BigInt::bytes
size_t bytes() const
Definition: bigint.cpp:273

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:205
Botan::OCTET_STRING
Definition: asn1_obj.h:36

const BigInt & Botan::EC_PrivateKey::private_value | ( |  | ) | const
| inherited

Get the private key value of this key object.

Returns
  the private key value of this key object

Definition at line 99 of file ecc_key.cpp.

100 {
101 if(m_private_key == 0)
102 throw Invalid_State("EC_PrivateKey::private_value - uninitialized");
103
104 return m_private_key;
105 }
Botan::EC_PrivateKey::m_private_key
BigInt m_private_key
Definition: ecc_key.h:167

std::vector< uint8_t > Botan::GOST_3410_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Reimplemented from Botan::EC_PublicKey.

Definition at line 19 of file gost_3410.cpp.

References Botan::BigInt::binary_encode(), Botan::BigInt::bytes(), Botan::DER_Encoder::encode(), Botan::PointGFp::get_affine_x(), Botan::PointGFp::get_affine_y(), Botan::OCTET_STRING, and Botan::EC_PublicKey::public_point().

20 {
21 const BigInt x = public_point().get_affine_x();
22 const BigInt y = public_point().get_affine_y();
23
24 size_t part_size = std::max(x.bytes(), y.bytes());
25
26 std::vector<uint8_t> bits(2*part_size);
27
28 x.binary_encode(&bits[part_size - x.bytes()]);
29 y.binary_encode(&bits[2*part_size - y.bytes()]);
30
31 // Keys are stored in little endian format (WTF)
32 for(size_t i = 0; i != part_size / 2; ++i)
33 {
34 std::swap(bits[i], bits[part_size-1-i]);
35 std::swap(bits[part_size+i], bits[2*part_size-1-i]);
36 }
37
38 std::vector<uint8_t> output;
39 DER_Encoder(output).encode(bits, OCTET_STRING);
40 return output;
41 }
Botan::PointGFp::get_affine_y
BigInt get_affine_y() const
Definition: point_gfp.cpp:518
Botan::EC_PublicKey::public_point
const PointGFp & public_point() const
Definition: ecc_key.h:57
Botan::PointGFp::get_affine_x
BigInt get_affine_x() const
Definition: point_gfp.cpp:499
Botan::OCTET_STRING
Definition: asn1_obj.h:36

const PointGFp& Botan::EC_PublicKey::public_point | ( |  | ) | const
| inline inherited

Get the public point of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the public point of this key

Definition at line 57 of file ecc_key.h.

Referenced by botan_pubkey_sm2_compute_za(), Botan::EC_PublicKey::check_key(), Botan::ECKCDSA_PrivateKey::check_key(), Botan::ECGDSA_PrivateKey::check_key(), Botan::SM2_PrivateKey::check_key(), Botan::ECDSA_PrivateKey::check_key(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::public_key_bits(), Botan::EC_PublicKey::public_key_bits(), and Botan::ECDSA_PublicKey::recovery_param().

57 { return m_public_key; }
Botan::EC_PublicKey::m_public_key
PointGFp m_public_key
Definition: ecc_key.h:115

void Botan::EC_PublicKey::set_parameter_encoding | ( | EC_Group_Encoding | enc | ) |
| inherited

Set the domain parameter encoding to be used when encoding this key.

Parameters

  enc | the encoding to use

Definition at line 84 of file ecc_key.cpp.

References Botan::EC_DOMPAR_ENC_EXPLICIT, Botan::EC_DOMPAR_ENC_IMPLICITCA, Botan::EC_DOMPAR_ENC_OID, Botan::OID::empty(), Botan::EC_Group::get_curve_oid(), Botan::EC_PublicKey::m_domain_encoding, and Botan::EC_PublicKey::m_domain_params.

85 {
86 if(form != EC_DOMPAR_ENC_EXPLICIT &&
87 form != EC_DOMPAR_ENC_IMPLICITCA &&
88 form != EC_DOMPAR_ENC_OID)
89 throw Invalid_Argument("Invalid encoding form for EC-key object specified");
90
91 if((form == EC_DOMPAR_ENC_OID) && (m_domain_params.get_curve_oid().empty()))
92 throw Invalid_Argument("Invalid encoding form OID specified for "
93 "EC-key object whose corresponding domain "
94 "parameters are without oid");
95
96 m_domain_encoding = form;
97 }
Botan::EC_DOMPAR_ENC_EXPLICIT
Definition: ec_group.h:24
Botan::EC_Group::get_curve_oid
const OID & get_curve_oid() const
Definition: ec_group.cpp:523
Botan::EC_DOMPAR_ENC_IMPLICITCA
Definition: ec_group.h:25
Botan::EC_DOMPAR_ENC_OID
Definition: ec_group.h:26
Botan::OID::empty
bool empty() const
Definition: asn1_oid.h:59
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:114
Botan::EC_PublicKey::m_domain_encoding
EC_Group_Encoding m_domain_encoding
Definition: ecc_key.h:116

void Botan::EC_PublicKey::set_point_encoding | ( | PointGFp::Compression_Type | enc | ) |
| inherited

Set the point encoding method to be used when encoding this key.

Parameters

  enc | the encoding to use

Definition at line 74 of file ecc_key.cpp.

References Botan::PointGFp::COMPRESSED, Botan::PointGFp::HYBRID, Botan::EC_PublicKey::m_point_encoding, and Botan::PointGFp::UNCOMPRESSED.

75 {
76 if(enc != PointGFp::COMPRESSED &&
77 enc != PointGFp::UNCOMPRESSED &&
78 enc != PointGFp::HYBRID)
79 throw Invalid_Argument("Invalid point encoding for EC_PublicKey");
80
81 m_point_encoding = enc;
82 }
Botan::PointGFp::COMPRESSED
Definition: point_gfp.h:52
Botan::PointGFp::UNCOMPRESSED
Definition: point_gfp.h:51
Botan::EC_PublicKey::m_point_encoding
PointGFp::Compression_Type m_point_encoding
Definition: ecc_key.h:117
Botan::PointGFp::HYBRID
Definition: point_gfp.h:53

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 189 of file pk_keys.h.

189 { return false; }

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:40
Botan::BIT_STRING
Definition: asn1_obj.h:35

## Member Data Documentation

EC_Group_Encoding Botan::EC_PublicKey::m_domain_encoding
| protected inherited

Definition at line 116 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), and Botan::EC_PublicKey::set_parameter_encoding().

EC_Group Botan::EC_PublicKey::m_domain_params
| protected inherited

Definition at line 114 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::check_key(), Botan::EC_PrivateKey::EC_PrivateKey(), GOST_3410_PrivateKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PublicKey::set_parameter_encoding().

PointGFp::Compression_Type Botan::EC_PublicKey::m_point_encoding = PointGFp::UNCOMPRESSED
| protected inherited

Definition at line 117 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::set_point_encoding().

BigInt Botan::EC_PrivateKey::m_private_key
| protected inherited

Definition at line 167 of file ecc_key.h.

Referenced by Botan::SM2_PrivateKey::SM2_PrivateKey().

PointGFp Botan::EC_PublicKey::m_public_key
| protected inherited

Definition at line 115 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PrivateKey::private_key_bits().

The documentation for this class was generated from the following files:

- src/lib/pubkey/gost_3410/gost_3410.h
- src/lib/pubkey/gost_3410/gost_3410.cpp